package si.mojeznanje.service.datoteka;

import com.fasterxml.jackson.databind.ObjectMapper;

/**
 * Created by Homez on 16/01/2018.
 */
@Deprecated
public class ZapisovalecCesarkoli extends Zapisovalec {

    protected String datoteka = "datoteka.json";

    public ZapisovalecCesarkoli(){

    }
    public ZapisovalecCesarkoli(String datoteka){
        this.datoteka = datoteka;
    }

    public <T> void shrani(T objekt){

        String podatki = "";
        ObjectMapper mapper = new ObjectMapper();

        try {
            podatki = mapper.writeValueAsString(objekt);
        }
        catch (Exception e){
            System.out.println("Napaka pri zapisovanju json");
        }

        shraniDatoteko(podatki, datoteka);
    }

    public <T> T preberi(Class<T> razred){

        T objekt = null;

        try {
            objekt = razred.newInstance();
        }
        catch (Exception e){
            System.out.println("Napaka pri kreaciji instance razreda " + razred);
        }

        String podatki = preberiDatoteko(datoteka);

        ObjectMapper mapper = new ObjectMapper();

        try {
            objekt = mapper.readValue(podatki, razred);
        }
        catch (Exception e){
            System.out.println("Napaka pri prebiranju podatkov iz json");
        }

        return objekt;
    }
}
