package si.mojeznanje.service.datoteka;

import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import si.mojeznanje.model.Zival;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by Homez on 11/01/2018.
 */
public class ZapisovalecZivaliJson extends ZapisovalecZivaliCSV {

    @Override
    public void shraniZivali(List<Zival> zivali){

        String podatki = "";
        ObjectMapper mapper = new ObjectMapper();
      //  mapper.enableDefaultTyping(
      //          ObjectMapper.DefaultTyping.OBJECT_AND_NON_CONCRETE);

        try {
            podatki = mapper.writeValueAsString(zivali);
        }
        catch (Exception e){
            System.out.println("Napaka pri zapisovanju json");
        }

        shraniDatoteko(podatki, datoteka);
    }

    @Override
    public List<Zival> preberiZivali(){

        List<Zival> zivali = new ArrayList<Zival>();

        String podatki = preberiDatoteko(datoteka);

        ObjectMapper mapper = new ObjectMapper();
    //    mapper.enableDefaultTyping(
    //            ObjectMapper.DefaultTyping.OBJECT_AND_NON_CONCRETE);

        try {
            zivali = mapper.readValue(podatki, new TypeReference<List<Zival>>(){});
        }
        catch (Exception e){
            System.out.println("Napaka pri prebiranju podatkov iz json");
        }


        return zivali;
    }
}
