package si.mojeznanje.service;

import si.mojeznanje.model.Macka;
import si.mojeznanje.model.Pes;
import si.mojeznanje.model.Riba;
import si.mojeznanje.model.Zival;

import javax.ws.rs.DELETE;
import java.sql.*;
import java.util.ArrayDeque;
import java.util.ArrayList;
import java.util.Collection;

/**
 * Created by saso on 18. 01. 2018.
 */
@Deprecated
public class ZapisovalecMySql
{
    private final String povezava = "jdbc:mysql://127.0.0.1/zivalski_vrt?user=root";


    public void shrani(Collection<Zival> zivali){
        for(Zival zival : zivali)
            shrani(zival);
    }

    public void shrani(Zival zival){
        if(zival == null)
            return;

        try {
            Class.forName("com.mysql.jdbc.Driver");
        }
        catch (Exception e){

        }

        try(Connection connection = DriverManager.getConnection(povezava)) {

            PreparedStatement statement =
                    connection.prepareStatement("insert into zival values (DEFAULT, ?, ? , ?, ?)");

            String tip = "";

            if(zival instanceof Pes){
                tip = "pes";
            }
            else if(zival instanceof Macka){
                tip = "macka";
            }
            else if(zival instanceof Riba){
                tip = "riba";
            }

            statement.setString(1,zival.getIme());
            statement.setInt(2, zival.getStarost());
            statement.setInt(3, zival.getSpol());
            statement.setString(4, tip);

            statement.executeUpdate();

        }
        catch (Exception e){
            System.out.println("Napaka pri zapisovanju v bazo");
        }
    }

    public Collection<Zival> preberiVseZivali(){
        Collection<Zival> zivali = new ArrayList<Zival>();

        try {
            Class.forName("com.mysql.jdbc.Driver");
        }
        catch (Exception e){

        }
        try(Connection connection = DriverManager.getConnection(povezava)) {
            Statement statement = connection.createStatement();

            ResultSet result = statement.executeQuery("SELECT * FROM zival");

            while (result.next()){
                String ime = result.getString("ime");
                String tip = result.getString("tip");
                Integer starost = result.getInt("starost");
                Integer spol = result.getInt("spol");

                Zival zival = null;

                if(tip.equals("pes")){
                    zival = new Pes();
                }
                else if(tip.equals("macka")){
                    zival = new Macka();
                }
                else  if(tip.equals("riba")){
                    zival = new Riba();
                }

                zival.setSpol(spol);
                zival.setStarost(starost);
                zival.setIme(ime);


                zivali.add(zival);
            }
        }
        catch (Exception e){
            System.out.println("Napaka pri zapisovanju v bazo");
        }

        return zivali;
    }

    public Collection<Zival> preberiZival(Integer id){
        Collection<Zival> zivali = new ArrayList<Zival>();

        try {
            Class.forName("com.mysql.jdbc.Driver");
        }
        catch (Exception e){

        }
        try(Connection connection = DriverManager.getConnection(povezava)) {
            Statement statement = connection.createStatement();

            ResultSet result = statement.executeQuery("SELECT * FROM zival WHERE id = " + id);

            while (result.next()){
                String ime = result.getString("ime");
                String tip = result.getString("tip");
                Integer starost = result.getInt("starost");
                Integer spol = result.getInt("spol");

                Zival zival = null;

                if(tip.equals("pes")){
                    zival = new Pes();
                }
                else if(tip.equals("macka")){
                    zival = new Macka();
                }
                else  if(tip.equals("riba")){
                    zival = new Riba();
                }

                zival.setSpol(spol);
                zival.setStarost(starost);
                zival.setIme(ime);


                zivali.add(zival);
            }
        }
        catch (Exception e){
            System.out.println("Napaka pri zapisovanju v bazo");
        }

        return zivali;
    }

    public void izbrisi(Zival zival){

    }

    public void posodobi(Zival zival){
        // where id = id
    }
}
