package si.mojeznanje.service.datoteka;

import java.io.*;

/**
 * Created by Homez on 11/01/2018.
 */
public class Zapisovalec
{
    protected static String preberiDatoteko(String datoteka){

        String podatki = "";

        try(BufferedReader reader = new BufferedReader( new FileReader(datoteka)))
        {
            StringBuilder stringBuilder = new StringBuilder();
            String vrstica = reader.readLine();

            while (vrstica != null) {
                stringBuilder.append(vrstica);
                stringBuilder.append(System.lineSeparator());
                vrstica = reader.readLine();
            }
            podatki = stringBuilder.toString();
        }
        catch ( IOException e)
        {
            System.out.println("Napaka pri pisanju datoteke " + datoteka);
        }

        return podatki;
    }

    protected static void shraniDatoteko(String podatki, String datoteka){

        try(BufferedWriter writer = new BufferedWriter( new FileWriter(datoteka)))
        {
            writer.write( podatki);
        }
        catch ( IOException e)
        {
            System.out.println("Napaka pri pisanju datoteke " + datoteka);
        }
    }
}
