package si.mojeznanje.service.ip;


import com.fasterxml.jackson.databind.ObjectMapper;
import si.mojeznanje.model.Lokacija;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;

/**
 * Created by saso on 23. 01. 2018.
 */
@Deprecated
public class IpApi {

    private static final String naslov = "http://ip-api.com/json";

    public static Lokacija mojaLokacija(){

        Lokacija lokacija = null;
        URL url = null;
        HttpURLConnection connection = null;

        try {

            url = new URL(naslov);
            connection = (HttpURLConnection) url.openConnection();
            connection.setRequestMethod("GET");
            connection.setRequestProperty("Content-Type", "application/json");
            connection.setConnectTimeout(5000);

            int status = connection.getResponseCode();

            BufferedReader reader =
                    new BufferedReader(new InputStreamReader(connection.getInputStream()));

            StringBuffer content = new StringBuffer();

            String line = null;

            while ((line = reader.readLine()) != null){
                content.append(line);
            }
            reader.close();


            ObjectMapper mapper = new ObjectMapper();

            lokacija = mapper.readValue(content.toString(), Lokacija.class);
        }
        catch (Exception e){
            System.out.println("napaka pri ip api");
        }
        finally {

            if(connection != null)
                connection.disconnect();
        }

        return lokacija;
    }
}
