package si.mojeznanje.service.ip;

import com.mchange.v2.log.LogUtils;
import si.mojeznanje.model.Lokacija;

import javax.ws.rs.client.Client;
import javax.ws.rs.client.ClientBuilder;
import javax.ws.rs.core.Response;

/**
 * Created by saso on 23. 01. 2018.
 */
public class IpApiJersey {

    private static final String naslov = "http://ip-api.com/xml";

    public static Lokacija mojaLokacija(){

        Lokacija lokacija = null;

        Client client = ClientBuilder.newClient();

        Response response = null;

        try {
            response = client.target(naslov)
                    .request()
                    .get();
        }
        catch (Exception e){
            System.out.println("jersey napaka");
        }

        if(response.getStatus() == Response.Status.OK.getStatusCode()){

            lokacija = response.readEntity(Lokacija.class);
        }
        else
        {
            return null;
        }
        return lokacija;
    }
}
