package si.mojeznanje.service.rest;

import si.mojeznanje.model.Ograda;
import si.mojeznanje.model.OgradaSet;
import si.mojeznanje.service.ZapisovalecHibernate;

import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import java.awt.*;

/**
 * Created by saso on 25. 01. 2018.
 */
@Path("/ograda")
public class OgradaService {

    @GET
    @Path("/{id}")
    @Produces(MediaType.APPLICATION_JSON)
    public Response getOgrada(@PathParam("id") Integer id){
        OgradaSet ograda = null;

        ZapisovalecHibernate zapisovalecHibernate = new ZapisovalecHibernate();

        ograda = zapisovalecHibernate.preberi(OgradaSet.class, id);

        return Response.ok(ograda).build();
    }
}
